require 'weaver/core/logging'
require 'weaver/dsl/requires/type_handler'
require 'weaver/core/requirements'

module Weaver
  module Dsl
    module Requires
      # Author:: Fabio Oliveira
      class FirewallTypeHandler < TypeHandler
        def initialize()
          super [ :firewall ]
        end

        def handle(parent, args)
          @@logger.debug "#{self.class} #{parent} #{args}" 
          return FirewallRequirement.new(parent.model, args) 
        end
      end
      
      class FirewallRequirement < Core::Requirement
        def initialize(scope, requires_hash)
          super scope
              
          @name = requires_hash[:firewall]
          @inport = requires_hash[:inport]
          @inport_range = requires_hash[:inport_range]
          @inprotocol = requires_hash[:in_protocol]
          @outport = requires_hash[:outport]
          @outport_range = requires_hash[:outport_range]
          @outprotocol = requires_hash[:out_protocol]
          # TODO warn if we have any additional keys in requires_hash besides :description
        end
        
        def validate_collect(out_messages, desired_phases = nil)
          #inf_node = get_final_realization()
           all_final_realizations.each do |inf_node|  
             unless inf_node.nil?
               @@logger.debug "Validating firewall requirement. Node = #{inf_node.id}"
               
#               storage = find_target_storage(inf_node)
#               if storage.nil?
#                 @@logger.debug "Could not find target storage for node #{inf_node.id}"
#                 out_messages.push ProblemStatus.new(Logger::ERROR, generate_storagenotattached_message(inf_node), inf_node, weaver_origin)
#               else
#                 @@logger.debug "Found node's target storage: #{storage.inspect}"
#                 required_size = convert_to_MB(@required_size, @required_unit)
#                 target_size = convert_to_MB(storage.size, storage.unit)
#                 if required_size > target_size
#                   out_messages.push ProblemStatus.new(Logger::ERROR, generate_insufficientstorage_message(inf_node, storage), inf_node, weaver_origin)
#                 end
#               end
             end               
           end
        end
      end
    end
  end
end