require 'weaver/core/rule'
require 'weaver/core/resolution'

module Weaver
  module Dsl
    # ResolutionStatement implements the processing of the language element 'resolution'.
    #
    #
    class ResolutionStatement
      include Weaver::Core

      # The model represents the Core::Resolution that corresponds to this statement
      attr_accessor :model
      
      # * +parent_statement+ The enclosing AbstractStatement
      def initialize(parent_statement)
        @@logger.debug "resolution"
        @model = Resolution.new()
        @parent = parent_statement
      end
      
      # Parse the 'type' of a resolution
      def type(res_type)
        @@logger.debug "type = #{res_type}"
        @model.type = res_type
      end
      
      # Parse the 'label' of a resolution
      def label(res_label)
        @@logger.debug "label = #{res_label}"
        @model.label = res_label
      end
      
      # Parse the 'description' of a resolution
      def description(res_description)
        @@logger.debug "description = #{res_description}"
        @model.description = res_description
      end
      
    end
  end

end