require 'weaver/core/user'

module Weaver
  module Dsl
    
    # Represents user credentials (typically an OS or LDAP username/password and metadata)
    # @see Weaver::Core::User
    #
    # Author:: Ed Snible
    # Copyright:: IBM
    class UserStatement < AbstractStatement

      # * +id+ Symbol representing the entity, or a Core::User which is the entity
      # * +parent_statement+ The enclosing AbstractStatement
      def initialize(id, parent_statement)
        @@logger.debug "user[id: #{id}]"
        super(id, :user, parent_statement)
      end

  	end
  end

end
